# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es
import langlib
import usermsg
import vecmath
import weaponlib
import gamethread

import os
import re

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


g_informations = es.AddonInfo()
g_informations["name"] = "FireBalls by L'In20Cible"
g_informations["version"] = "1.1"
g_informations["date"] = "2010-06-31"
g_informations["author"] = "L\'in20Cible"
g_informations["url"] = "http://addons.eventscripts.com/addons/view/fireballs/"
g_informations["basename"] = "fireballs"

es.ServerVar((g_informations["basename"] + "_version"), (g_informations["version"] + " by " + g_informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


g_options = {
   "enable"       : [1  , "fireballs_enable <1/0> -- Active/Désactive les balles de feu."],
   "radius"       : [250, "fireballs_radius <int> -- Définit le rayon dans lequel les joueurs seront affecté par l'explosion d'une balle de feu."],
   "friendlyfire" : [0  , "fireballs_friendlyfire <1/0> -- Active/Désactive les dommages causés par une balle de feu entre les joueurs d'une même équipe."],
   "maxamount"    : [50 , "fireballs_maxamount <int> -- Définit la quantité maximale de balle de feu par round."],
   "framerate"    : [0  , "fireballs_delay <float> -- Définit le délais d'attente entre deux balles de feu."],
   "multiplier"   : [10 , "fireballs_multiplier <float> -- Définit le multiplicateur de la vitesse des balles de feu."],
   "sounds"       : [1  , "fireballs_sounds <1/0> -- Active/Désactive les sons des balles de feu."]
   }
for option in g_options:
   g_options[option] = es.ServerVar((g_informations["basename"] + "_" + option), g_options[option][0], g_options[option][1])
   
   
# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   __init__()
   es.server.queuecmd("mp_restartgame 1")
   es.addons.registerTickListener(TickListenerCallback)
   if es.exists("command", "fireballs"):
      return
   es.regcmd("fireballs", os.path.join(g_informations["basename"], "ServerCommandCallBack").replace(os.sep, "/"))
   
   
def __init__():
   global g_players, g_spammers, g_fireballs, g_weapons, g_weaponlist, g_translations
   g_players, g_spammers, g_fireballs = dict(), list(), list()
   filepath = GetConfigurationFilePath("configuration.cfg")
   if os.path.isfile(filepath):
      es.mexec(filepath.replace(str(es.ServerVar("eventscripts_gamedir")).replace(os.sep, "/"), ".."))
   g_weapons = list()
   filepath = GetConfigurationFilePath("weapons.txt")
   if os.path.isfile(filepath):
      regex = re.compile("//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\n)+")
      for fileline in open(filepath):
         fileline = regex.sub("", fileline).strip()
         if not fileline:
            continue
         g_weapons.append(fileline)
   g_weaponlist = (weaponlib.getWeaponList("#primary") + weaponlib.getWeaponList("#secondary"))
   g_translations = TranslationFileIsMissingCallBack
   filepath = GetConfigurationFilePath("translations.ini")
   if not os.path.isfile(filepath):
      return
   g_translations = langlib.Strings(filepath)
   g_translations.fallback = "en"
   
   
def unload():
   es.addons.unregisterTickListener(TickListenerCallback)
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetConfigurationFilePath(filename):
   return os.path.join(str(es.ServerVar("eventscripts_gamedir")), "cfg", "eventscripts", g_informations["basename"], filename).replace(os.sep, "/")
   
   
def GetPlayerEyeLocation(userid):
   returnvalue = (0.0, 0.0, 0.0)
   x, y, z = es.getplayerlocation(userid)
   z = (z + 66.7)
   if (es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2):
      z = (z - 16.1)
   return es.createvectorstring(x, y, z)
   
   
def GetPlayerViewLocation(userid):
   returnvalue = (0.0, 0.0, 0.0)
   entities = es.createentitylist("prop_dynamic")
   ExecutePlayerCheat(userid, "prop_dynamic_create props_c17/tv_monitor01_screen.mdl")
   for index in es.createentitylist("prop_dynamic"):
      if (index in entities):
         continue
      returnvalue = es.entitygetvalue(index, "Origin").replace(" ", ",")
      RemoveEntityByIndex(userid, index)
      break
   return returnvalue
   
   
def ExecutePlayerCheat(userid, string):
   if int(es.ServerVar("sv_cheats")):
      es.sexec(userid, string)
   else:
      es.forcevalue("sv_cheats", 1)
      es.sexec(userid, string)
      es.forcevalue("sv_cheats", 0)
      
      
def RemoveEntityByIndex(userid, index):
   es.entitysetvalue(index, "TargetName", index)
   es.fire(userid, index, "Kill")
   
   
def ExplosePlayerFireBall(userid, index):
   if (index not in g_fireballs):
      return
   g_fireballs.remove(index)
   if int(g_options["sounds"]):
      es.emitsound("entity", index, "weapons/c4/c4_explode1.wav", 1.0, 0.5)
   es.setentityname(index, ("gib_" + str(userid)))
   es.fire(userid, ("gib_" + str(userid)), "DispatchEffect", "Explosion")
   es.fire(userid, ("gib_" + str(userid)), "DispatchEffect", "ManHackSparks")
   es.fire(userid, ("gib_" + str(userid)), "DispatchEffect", "HelicopterMegaBomb")
   origin = es.entitygetvalue(index, "Origin")
   es.fire(userid, ("gib_" + str(userid)), "Kill")
   index = es.createentity("env_physexplosion", ("env_physexplosion_" + str(userid)))
   outputs = {
      "Radius"    : int(g_options["radius"]),
      "Magnitude" : 500,
      "SpawnFlags": 1,
      "Origin"    : origin
      }
   for output in outputs:
      es.entitysetvalue(index, output, outputs[output])
   es.fire(userid, ("env_physexplosion_" + str(userid)), "Explode")
   es.fire(userid, ("env_physexplosion_" + str(userid)), "Kill")
   index = es.createentity("env_explosion", ("env_explosion_" + str(userid)))
   outputs = {
      "iMagnitude"     : 500,
      "RenderMode"     : 5,
      "SpawnFlags"     : 1,
      "Origin"         : origin,
      "iRadiusOverride": int(g_options["radius"])
      }
   for output in outputs:
      es.entitysetvalue(index, output, outputs[output])
   es.fire(userid, ("env_explosion_" + str(userid)), "Explode")
   es.fire(userid, ("env_explosion_" + str(userid)), "Kill")
   for player in es.getUseridList():
      if es.getplayerprop(player, "CBasePlayer.pl.deadflag") or ((int(g_options["friendlyfire"]) == 0) and (es.getplayerteam(userid) == es.getplayerteam(player))):# and (player != userid)):
         continue
      distance = vecmath.distance(origin.replace(" ", ","), es.getplayerlocation(player))
      if (distance < int(g_options["radius"])):
         damage = int(int(g_options["radius"]) * 100 / distance / 3)
         usermsg.shake(player, damage, 1.0)
         es.server.queuecmd(" ".join(["damage", str(player), str(damage), "32", str(userid)]))
         
         
# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def TranslationFileIsMissingCallBack(string, tokens, language):
   return "Sorry, the translations file is missing."
   
   
def TickListenerCallback():
   for index in g_fireballs:
      es.effect("smoke", es.getindexprop(index, "CBaseEntity.m_vecOrigin"), "smoke", 10, 2.0)
      
      
def ServerCommandCallBack():
   userid = int(es.getargv(1))
   if not es.exists("userid", userid):
      return
   g_spammers.append(userid)
   gamethread.delayed(float(g_options["framerate"]), g_spammers.remove, userid)
   if (g_players[userid] <= 0):
      return es.centertell(userid, g_translations("empty", dict(), langlib.getLangAbbreviation(es.getclientvar(userid, "cl_language"))))
   origin = GetPlayerEyeLocation(userid)
   vector = (vecmath.vector(es.createvectorfrompoints(origin, GetPlayerViewLocation(userid))) * float(g_options["multiplier"]))
   index = es.createentity("prop_physics_override", ("fireball_" + str(userid)))
   es.precachemodel("models/weapons/w_grenade.mdl")
   offsets = {
      "Model"    : "models/weapons/w_grenade.mdl",
      "Origin"   : origin.replace(",", " "),
      "ClassName": "prop_physics_multiplayer"
      }
   for offset in offsets:
      es.entitysetvalue(index, offset, offsets[offset])
   es.setindexprop(index, "CBaseEntity.m_CollisionGroup", 2)
   es.spawnentity(index)
   es.fire(userid, "prop_physics_multiplayer", "Wake")
   gamethread.delayed(0.01, es.server.queuecmd, ("es_physics active setvelocity %i %s" % (index, vector)))
   gamethread.delayed(0.05, es.setindexprop, (index, "CBaseEntity.m_CollisionGroup", 9))
   g_fireballs.append(index)
   gamethread.delayed(1.0, ExplosePlayerFireBall, (userid, index))
   if int(g_options["sounds"]):
      es.emitsound("entity", index, "weapons/rpg/rocketfire1.wav", 1.0, 0.5)
   index = es.createentity("env_entity_igniter")
   offsets = {
      "Target"  : ("fireball_" + str(userid)),
      "LifeTime": 30
      }
   for offset in offsets:
      es.entitysetvalue(index, offset, offsets[offset])
   es.fire(userid, "env_entity_igniter", "Ignite")
   es.fire(userid, "env_entity_igniter", "Kill")
   g_players[userid] = (g_players[userid] - 1)
   es.centertell(userid, g_translations("remaining", {"amount": g_players[userid], "total": int(g_options["maxamount"])}, langlib.getLangAbbreviation(es.getclientvar(userid, "cl_language"))))
   
   
   
# ==================================================
# >> ÉVÉNEMENTS
# ==================================================


def es_map_start(event_var):
   __init__()
   
   
def round_start(event_var):
   global g_fireballs
   if not len(g_fireballs):
      return
   g_fireballs = list()
   
   
def player_disconnect(event_var):
   userid = int(event_var["userid"])
   if (userid in g_players):
      del g_players[userid]
   if (userid not in g_spammers):
      return
   g_spammers.remove(userid)
   
   
def item_pickup(event_var):
   userid, item = int(event_var["userid"]), ("weapon_" + event_var["item"])
   if not int(g_options["enable"]) or es.isbot(userid) or es.getplayerprop(userid, "CBasePlayer.pl.deadflag") or (item not in g_weapons) or (item not in g_weaponlist):
      return
   for index in es.createentitylist(item):
      if (es.getindexprop(index, "CBaseEntity.m_hOwnerEntity") != es.getplayerhandle(userid)):
         continue
      es.setplayerprop(userid, weaponlib.getWeapon(item).prop, 0)
      es.setindexprop(index, "CBaseCombatWeapon.LocalWeaponData.m_iClip1", 0)
      break
   es.tell(userid, "#multi", ("#green[FireBalls] #default" + g_translations("pickup", dict(), langlib.getLangAbbreviation(es.getclientvar(userid, "cl_language")))))
   
   
def weapon_fire_on_empty(event_var):
   userid, weapon = int(event_var["userid"]), ("weapon_" + event_var["weapon"])
   if not int(g_options["enable"]) or (weapon not in g_weapons) or (weapon not in g_weaponlist) or (userid in g_spammers):
      return
   es.server.queuecmd(("fireballs " + str(userid)))
   
   
def player_spawn(event_var):
   if not int(g_options["enable"]) or (int(event_var["es_userteam"]) not in [2, 3]):
      return
   userid = int(event_var["userid"])
   for weapon in g_weapons:
      if (weapon not in g_weaponlist):
         continue
      for index in es.createentitylist(weapon):
         if (es.getindexprop(index, "CBaseEntity.m_hOwnerEntity") != es.getplayerhandle(userid)):
            continue
         es.setplayerprop(userid, weaponlib.getWeapon(weapon).prop, 0)
         es.setindexprop(index, "CBaseCombatWeapon.LocalWeaponData.m_iClip1", 0)
         break
   g_players[userid] = int(g_options["maxamount"])